GO
-- Nowy wymiar i pole dodatkowe - tylko jeeli pole o takiej nazwie jeszcze nie istnieje
IF COL_LENGTH('SSCommon.[HMF_SalesInvoiceClassification]','CDim_JPK_OSS')  IS NULL 
BEGIN
DECLARE @DimGuid uniqueidentifier  
SET @DimGuid = NEWID()  

insert into SSCommon.STDimensions
select 
	'Procedura OSS' as Name,
	NULL as ElementKindGuid,
	'JPK_OSS' as Symbol,
	@DimGuid as Guid,
	'System.Boolean, mscorlib' as DimCLRType,
	GETDATE() as st_last_modified,
	NULL as st_shadowdata

DECLARE @DimId INT
SET @DimId = (SELECT Id FROM SSCommon.STDimensions WHERE Guid = @DimGuid)

DECLARE @ClasDefId INT --id Definicja klasyfikacji dokumentw sprzeday - HMF
SET @ClasDefId = (SELECT Id FROM SSCommon.STClasificationsDef WHERE Guid = '3DA34DE1-F537-4110-949F-8F3A5947B0E1')

DECLARE @DimOrder INT
SET @DimOrder = (SELECT MAX(DimOrder) FROM SSCommon.STClasificationDims WHERE ClasificationsDefId = @ClasDefId)
SET @DimOrder = @DimOrder + 1

INSERT INTO SSCommon.STClasificationDims
SELECT 
	@ClasDefId as ClasificationsDefId,
	@DimId as DimensionsId,
	NULL as DefaultValue,
	NEWID() as Guid,
	@DimOrder as DimOrder,
	0 as DimActive,
	NULL as DimOrderBI,
	1 as DimVisible,
	GETDATE() as st_last_modified,
	NULL as st_shadowdata

ALTER TABLE SSCommon.[HMF_SalesInvoiceClassification] ADD[CDim_JPK_OSS] bit NULL
ALTER TABLE SSCommon.[HMF_SalesInvoiceClassificationRep] ADD[CDim_JPK_OSS] bit NULL
END
GO

--aktualizacja triggerw
--procedura usuwa i tworzy od nowa widoki i trigery dla klasyfikacji
--aktualizuje wszystkie kolumny _Value w klasyfikacjach, ktre maj SaveDictValues = 1

DECLARE @tsql nvarchar(MAX);
DECLARE @tsql2 nvarchar(MAX);
DECLARE @table_name sysname;
DECLARE @TableNamePrefix sysname;
DECLARE @ParmDefinition nvarchar(500);

DECLARE @UseIntFK bit;
DECLARE @BIMaxCount tinyint;
DECLARE @UsedBI tinyint;
DECLARE @CurrentBI tinyint;
DECLARE @ElementsIndx int;

DECLARE @FromAndJoin nvarchar(MAX);
DECLARE @LeftOuterJoins nvarchar(MAX);
DECLARE @ClasifingCols nvarchar(MAX);
DECLARE @ClasifiedCols nvarchar(MAX);
DECLARE @DimsCols nvarchar(MAX);
DECLARE @ElemsCols nvarchar(MAX);

DECLARE @TriggerCols nvarchar(MAX);
DECLARE @TriggerWithoutElIdCols nvarchar(MAX);
DECLARE @InsertedTriggerCols nvarchar(MAX);

DECLARE @SpecificValCols nvarchar(MAX);
set @SpecificValCols = ''

DECLARE @PartUpdateDimValue nvarchar(MAX);
DECLARE @UpdateDimValues nvarchar(MAX);

DECLARE @ColName sysname;

DECLARE @DimCLRType nvarchar(250);

DECLARE @TabName sysname;
DECLARE @TabSchema sysname;

DECLARE @FullTableName sysname;
DECLARE @EK uniqueidentifier;

DECLARE @ClasificationId int;

DECLARE @is_disabled bit;
------------

DECLARE @InsertedTriggerValCols nvarchar(MAX);
set @InsertedTriggerValCols =''
DECLARE @column_nameVal sysname;
DECLARE @TriggerValUpdate nvarchar(MAX);
DECLARE @addValUpdate bit = 0;
set @TriggerValUpdate = ''

DECLARE @column_nameWithVal sysname;
DECLARE @AllValCols nvarchar(MAX);
DECLARE @addColumnsWithValUpdate bit = 0;
set @AllValCols = ''
------------
DECLARE ClasVIEWCursos CURSOR STATIC LOCAL FOR 
select clas.tablenameprefix, clas.tablename, clas.UseIntFK, def.BIDimsMaxCount, clas.Id from SSCommon.STClasifications clas 
inner join SSCommon.STClasificationsDef def on clas.ClasificationsDefId = def.Id --where clas.TableName = 'HMF_SalesInvoiceClassification'; ; 
Open ClasVIEWCursos

FETCH NEXT FROM ClasVIEWCursos INTO @TableNamePrefix, @table_name, @UseIntFK, @BIMaxCount, @ClasificationId;
WHILE @@FETCH_STATUS = 0
BEGIN

	SET @TriggerCols = '[Guid], [ElementId]';
	SET @TriggerWithoutElIdCols = '[Guid]';
	SET @InsertedTriggerCols = '[Guid] = inserted1.[Guid], [ElementId] = inserted1.[ElementId]';

	SET @UpdateDimValues = NULL;

	SET @tsql = 'IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N''[SSCommon].[KL_VIEW_' + @table_name + ']''))
	DROP VIEW [SSCommon].[KL_VIEW_' + @table_name + ']';

	exec sp_executesql @tsql;

	SET @CurrentBI = 0;
	SET @UsedBI = 0;

	SET @ClasifingCols = NULL;
	SET @ClasifiedCols = NULL;

	SET @FullTableName = ISNULL(@TableNamePrefix, '') + @table_name;
					
	DECLARE @ColNameOUT sysname;
	DECLARE @TabNameOUT sysname;
	DECLARE @TabSchemaOUT sysname;

	SET @ParmDefinition = N'@ColNameOUT sysname OUTPUT, @TabNameOUT sysname OUTPUT, @TabSchemaOUT sysname OUTPUT'
	set @tsql = 'select @TabNameOUT = OBJECT_NAME(fkc.referenced_object_id), @TabSchemaOUT = OBJECT_SCHEMA_NAME(fkc.referenced_object_id), @ColNameOUT = COL_NAME(fkc.referenced_object_id, fkc.referenced_column_id)
	from sys.columns cols 
	inner join sys.foreign_key_columns fkc on cols.object_id = fkc.parent_object_id and cols.column_id = fkc.parent_column_id 
	where OBJECT_NAME(cols.object_id) = ''' + ISNULL(@TableNamePrefix, '') + @table_name + ''' and cols.name = ''ElementId''';

	EXECUTE sp_executesql
	@tsql,
	@ParmDefinition,
	@ColNameOUT=@ColName OUTPUT, 
	@TabNameOUT = @TabName OUTPUT, 
	@TabSchemaOUT = @TabSchema OUTPUT;

	DECLARE @tabAlias sysname;
					
	DECLARE ColsCursos CURSOR STATIC LOCAL FOR 
	select COLUMN_NAME from INFORMATION_SCHEMA.COLUMNS where TABLE_NAME = @TabName and COLUMN_NAME not in ('st_last_modified','st_shadowdata') order by ORDINAL_POSITION
	Open ColsCursos

	FETCH NEXT FROM ColsCursos INTO @ColNameOUT;
	WHILE @@FETCH_STATUS = 0
	BEGIN
	IF @ClasifiedCols IS NULL
		SET @ClasifiedCols = @TabName + '0.[' + @ColNameOUT+']';
	ELSE
	BEGIN
		SET @ClasifiedCols = @ClasifiedCols + ', ';
		SET @ClasifiedCols = @ClasifiedCols + @TabName + '0.[' + @ColNameOUT+']';
	END

	FETCH NEXT FROM ColsCursos INTO @ColNameOUT;
	END
	CLOSE ColsCursos;
	DEALLOCATE ColsCursos;

	DECLARE DimValuesCursor CURSOR STATIC LOCAL FOR 
	select ' [' + cl2.COLUMN_NAME + '] = (SELECT [Title] FROM [SSCommon].[STElements] WHERE ' + case when c.UseIntFK = 0 then '[Guid]' else '[ElementId]' end + ' = clas.[' + cl1.COLUMN_NAME + '])'
	from SSCommon.STClasifications c 
	inner join SSCommon.STClasificationsDef d on c.ClasificationsDefId = d.Id 
	inner join SSCommon.STClasificationDims cdim on cdim.ClasificationsDefId = d.Id 
	inner join SSCommon.STDimensions dim on cdim.DimensionsId = dim.Id 
	inner join information_schema.columns cl1 on cl1.TABLE_NAME = ISNULL(c.TableNamePrefix, '') + c.TableName and cl1.COLUMN_NAME = 'CDim_' + replace(replace(replace(dim.Symbol,'-','_'),'.','_'), ' ', '#') 
	inner join information_schema.columns cl2 on cl1.TABLE_NAME = cl2.TABLE_NAME and cl1.COLUMN_NAME + '_Val' = cl2.COLUMN_NAME 
	where c.Id = @ClasificationId and c.SaveDictValues = 1 and dim.ElementKindGuid IS NOT NULL
	Open DimValuesCursor

	FETCH NEXT FROM DimValuesCursor INTO @PartUpdateDimValue;
	WHILE @@FETCH_STATUS = 0
	BEGIN
	IF @UpdateDimValues IS NULL
		SET @UpdateDimValues = 'UPDATE SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + '] 
		SET '; 
	ELSE
		SET @UpdateDimValues = @UpdateDimValues + ', 
		';

	SET @UpdateDimValues = @UpdateDimValues + @PartUpdateDimValue;

	FETCH NEXT FROM DimValuesCursor INTO @PartUpdateDimValue;
	END
	CLOSE DimValuesCursor;
	DEALLOCATE DimValuesCursor;

	IF @UpdateDimValues IS NOT NULL 
		BEGIN
			SET @UpdateDimValues = @UpdateDimValues + ' 
			FROM SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + '] as clas INNER JOIN inserted as inserted1 ON (inserted1.[ElementId]=clas.[ElementId]) ;';

		END


	DECLARE ColsCursos CURSOR STATIC LOCAL FOR 
	select COLUMN_NAME from INFORMATION_SCHEMA.COLUMNS where TABLE_NAME = @FullTableName and COLUMN_NAME like 'CDim_%' order by ORDINAL_POSITION
	Open ColsCursos

	FETCH NEXT FROM ColsCursos INTO @ColNameOUT;
	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF @ClasifingCols IS NULL
			SET @ClasifingCols = @table_name + '1.' + @ColNameOUT;
		ELSE
		BEGIN
			SET @ClasifingCols = @ClasifingCols + ', ';
			SET @ClasifingCols = @ClasifingCols + @table_name + '1.' + @ColNameOUT;
		END

	FETCH NEXT FROM ColsCursos INTO @ColNameOUT;
	END
	CLOSE ColsCursos;
	DEALLOCATE ColsCursos;


	SET @FromAndJoin = 'FROM ' + @TabSchema + '.[' + @TabName + '] as ' + @TabName + '0'; 
	SET @FromAndJoin = @FromAndJoin + ' INNER JOIN SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + '] as ' + @table_name + 
	'1 ON (' + @table_name + '1.[ElementId] = ' + @TabName + '0.[' + @ColName + ']) ';


	SET @ElementsIndx = 1;
	SET @LeftOuterJoins = NULL;
	SET @ElemsCols = NULL;

	DECLARE @ElemsColName sysname;

	if @UseIntFK = 0
		SET @ElemsColName = 'Guid';
	else
		SET @ElemsColName = 'ElementId';


	DECLARE DimsCursos CURSOR STATIC LOCAL FOR 
	select 'CDim_' + replace(replace(replace(dim.Symbol,'-','_'),'.','_'), ' ', '#'), cdim.DimOrderBI, dim.ElementKindGuid, dim.DimCLRType from SSCommon.STClasifications c 
	inner join SSCommon.STClasificationsDef d on c.ClasificationsDefId = d.Id
	inner join SSCommon.STClasificationDims cdim on cdim.ClasificationsDefId = d.Id 
	inner join SSCommon.STDimensions dim on cdim.DimensionsId = dim.Id
	where TableName = @table_name 
	order by ISNULL(cdim.DimOrderBI, 0)


	Open DimsCursos

	FETCH NEXT FROM DimsCursos INTO @ColName, @CurrentBI, @EK, @DimCLRType;
	WHILE @@FETCH_STATUS = 0
	BEGIN

	while patindex('%##%', @ColName) > 0
	begin
		set @ColName = replace(@ColName, '##', '#')
	end

	IF patindex('%(%', @ColName) > 0
		set @ColName = replace(@ColName, '(', '_')

	IF patindex('%)%', @ColName) > 0
		set @ColName = replace(@ColName, ')', '_')


	SET @TriggerCols = @TriggerCols + ', [' + @ColName + ']';
	SET @TriggerWithoutElIdCols = @TriggerWithoutElIdCols + ', [' + @ColName + ']';
	SET @InsertedTriggerCols = @InsertedTriggerCols + ', [' + @ColName + '] = inserted1.[' + @ColName + ']';

	if @EK IS NOT NULL
	BEGIN
		DECLARE @elemAlias sysname;
		SET @elemAlias = 'Elements' + convert(nvarchar(10),@ElementsIndx);
		SET @ElementsIndx = @ElementsIndx + 1;

		SET @LeftOuterJoins = ISNULL(@LeftOuterJoins, ' ') + 'LEFT OUTER JOIN SSCommon.[STElements] as ' + @elemAlias + ' ON (' 
		+ @elemAlias + '.[' + @ElemsColName + ']=' + @table_name + '1.[' + @ColName + ']) ';

		SET @ElemsCols = ISNULL(@ElemsCols + ', ', ' ') + @elemAlias + '.[Title] AS ' + @ColName + '_Title,' 
		+ @elemAlias + '.[Shortcut] AS ' + @ColName + '_Shortcut,'
		+ @elemAlias + '.[Active] AS ' + @ColName + '_Active ';

		IF @CurrentBI IS NOT NULL
		BEGIN
			SET @ElemsCols = @ElemsCols + ', ' + @elemAlias + '.[ElementId] AS CDim_BI_' + convert(nvarchar(2),@CurrentBI) + ' ';
			SET @UsedBI = @UsedBI + 1;
		END
	END

	FETCH NEXT FROM DimsCursos INTO @ColName, @CurrentBI, @EK, @DimCLRType;
	END
	CLOSE DimsCursos;
	DEALLOCATE DimsCursos;

	WHILE @UsedBI < @BIMaxCount
	BEGIN
		SET @ClasifingCols = ISNULL(@ClasifingCols  + ', ', '') + 'NULL AS CDim_BI_' + convert(nvarchar(2),@UsedBI) + ' ';
		SET @UsedBI = @UsedBI + 1;
	END

	set @tsql = 'CREATE VIEW SSCommon.[KL_VIEW_' + @table_name + '] AS ';

	if @ClasifingCols is null
		set @tsql = @tsql + 'SELECT ' + @ClasifiedCols;
	else
		set @tsql = @tsql + 'SELECT ' + @ClasifingCols + ', ' + @ClasifiedCols;

	IF isnull(@ElemsCols, '') <> '' 
		set @tsql = @tsql + ', ' + @ElemsCols;

	set @tsql = @tsql + ' ' + @FromAndJoin;

	IF isnull(@LeftOuterJoins, ' ') <> ' '
		SET @tsql = @tsql + ' ' + @LeftOuterJoins;


	exec sp_executesql @tsql;

	SET @ParmDefinition = N'@is_disabledOUT bit OUTPUT';

	SET @tsql = 'if exists (select ob.* from sys.objects ob inner join sys.schemas sch on ob.schema_id = sch.schema_id where ob.name = ''' + @table_Name + '_TH_IOI'' and ob.type = ''TR'' and sch.name = ''SSCommon'')
	BEGIN
	SELECT @is_disabledOUT = tr.is_disabled 
	FROM   sys.tables t
	INNER JOIN sys.schemas s ON t.schema_id = s.schema_id 
	inner join sys.triggers tr on tr.parent_id = t.object_id 
		and tr.type = ''TR'' -- SQL trigger (CLR-owych chyba nie mamy)
		and parent_class = 1 -- DML triggers
	WHERE s.name = ''SSCommon'' AND t.name = ''' + ISNULL(@TableNamePrefix, '') + @table_name + ''' AND tr.name = ''' + @table_name + '_TH_IOI'';
	DROP TRIGGER [SSCommon].[' + @table_name + '_TH_IOI]
	END';

	EXECUTE sp_executesql
	@tsql,
	@ParmDefinition,
	@is_disabledOUT=@is_disabled OUTPUT;

	--trigger _val cols 
	set @AllValCols = ''
	set @InsertedTriggerValCols = ''
	DECLARE TriggerValColumns CURSOR FOR 
		SELECT column_name from information_schema.columns where TABLE_NAME = (select @table_name+'Rep') and column_name like '%_Val'
	Open TriggerValColumns
	FETCH NEXT FROM TriggerValColumns INTO @column_nameWithVal
	WHILE @@FETCH_STATUS = 0
	BEGIN
		SET @addColumnsWithValUpdate = 1
		set @AllValCols = @AllValCols + ' ['+@column_nameWithVal+'],'
		set @InsertedTriggerValCols = @InsertedTriggerValCols + ', [' + @column_nameWithVal + '] = inserted1.[' + @column_nameWithVal + ']';
		FETCH NEXT FROM TriggerValColumns INTO @column_nameWithVal;
	END
	CLOSE TriggerValColumns;
	DEALLOCATE TriggerValColumns;

	IF @addColumnsWithValUpdate = 0
	begin
	 set @AllValCols = ''
	 set @InsertedTriggerValCols = ''
	end
	--

	---------------------	
	set @TriggerValUpdate = 'UPDATE SSCommon.['+@table_name+'] SET '

	DECLARE ValColCursors CURSOR FOR 
		SELECT column_name from information_schema.columns where TABLE_NAME = @table_name and column_name like '%_Val'
	Open ValColCursors
		FETCH NEXT FROM ValColCursors INTO @column_nameVal;
		WHILE @@FETCH_STATUS = 0
		BEGIN
			SET @addValUpdate = 1
			set @TriggerValUpdate = @TriggerValUpdate + '[' + @column_nameVal + '] = (SELECT [Title] FROM [SSCommon].[STElements] WHERE [ElementId] = '+@table_name+'0.['+replace(@column_nameVal,'_Val','')+']),'	
			FETCH NEXT FROM ValColCursors INTO @column_nameVal;
		END
	CLOSE ValColCursors;
	DEALLOCATE ValColCursors;

	set @TriggerValUpdate = (Select left(@TriggerValUpdate, len(@TriggerValUpdate)-1)) 
	select @TriggerValUpdate = @TriggerValUpdate + ' FROM [SSCommon].['+@table_name+'] as '+@table_name+'0 INNER JOIN inserted as inserted1 ON (inserted1.[ElementId]='+@table_name+'0.[ElementId]);'

	IF @addValUpdate = 0
	begin
	 set @TriggerValUpdate = ''
	end
	-------------------
	SET @tsql = 'CREATE TRIGGER [SSCommon].[' + @table_name + '_TH_IOI] 
   ON SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + '] 
   INSTEAD OF INSERT
AS 
BEGIN
	SET NOCOUNT ON;

    DECLARE @CI                varchar(128)     = context_info();
    DECLARE @st_modified_by    uniqueidentifier = ''00000000-0000-0000-0000-000000000000'';
    DECLARE @st_replication_id uniqueidentifier = ''00000000-0000-0000-0000-000000000000'';
    DECLARE @st_state          int              = 2;
    DECLARE @st_server         varchar(100)     = RTRIM(CONVERT(char(100), SERVERPROPERTY(''servername'')));
    DECLARE @st_last_modified  datetime         = GETDATE();
    DECLARE @ID_INS            char(1)          = ''0'';
    DECLARE @is_mirror_db_guid char(1)          = ''0'';
	DECLARE @skip_history      char(1)          = ''0'';
    DECLARE @st_db_guid        uniqueidentifier = ''00000000-0000-0000-0000-000000000000'';    
    DECLARE @endpos            int              = CHARINDEX(''*'', @CI);
    
    if (@endpos > 0)
    BEGIN
	    DECLARE @divpos1 int = CHARINDEX(''@'', @CI);
	    DECLARE @divpos2 int = CHARINDEX(''$'', @CI);
	    DECLARE @divpos4 int = CHARINDEX(''^'', @CI);
	    DECLARE @divpos5 int = CHARINDEX(''&'', @CI);
	    DECLARE @divpos6 int = CHARINDEX(''|'', @CI);
	    DECLARE @divpos7 int = CHARINDEX(''#'', @CI);	    	    

        SET @st_modified_by    = SUBSTRING(@CI, 1,            @divpos1 - 1);
	    SET @st_replication_id = SUBSTRING(@CI, @divpos1 + 1, @divpos2 - @divpos1 - 1);
	    SET @ID_INS            = SUBSTRING(@CI, @divpos4 + 1, @divpos5 - @divpos4 - 1);
	    SET @is_mirror_db_guid = SUBSTRING(@CI, @divpos6 + 1, @divpos7 - @divpos6 - 1);
		SET @skip_history =		 SUBSTRING(@CI, @divpos7+1,   LEN(@CI) - @divpos7);
	    
	    IF @is_mirror_db_guid = ''1''
	    BEGIN			
			SET @st_db_guid = @st_replication_id;
			SET @st_replication_id = ''00000000-0000-0000-0000-000000000000'';
		END
    END;

	IF(@skip_history <> ''1'')
	BEGIN
	INSERT INTO SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + 'Rep]
	(' + @TriggerCols +','+ @AllValCols+ ' st_last_modified, st_shadowdata , st_state, st_modified_by, st_host, st_client, st_server, st_replication_id, st_db_guid)
		SELECT
		    ' + @TriggerCols + ','
			+@AllValCols+'
		    @st_last_modified,
		    NULL,
		    @st_state,
		    @st_modified_by,
		    HOST_NAME(),
		    APP_NAME(),
		    @st_server,
		    @st_replication_id, 
		    @st_db_guid
		FROM inserted;
	END

	SET NOCOUNT OFF;
    
    IF @ID_INS = ''1''   
		INSERT INTO SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + '] 
		    (' + @TriggerCols +','+@AllValCols +' st_last_modified, st_shadowdata) 
			SELECT ' + @TriggerCols +','+@AllValCols +' @st_last_modified, NULL
			FROM inserted;
	ELSE
		INSERT INTO SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + '] 
		(' + @TriggerCols+','+@AllValCols +'  st_last_modified, st_shadowdata)
			SELECT ' + @TriggerCols +','+@AllValCols +'  @st_last_modified, NULL
			FROM inserted;

	SET NOCOUNT ON;

	'+@TriggerValUpdate+'
END;'

	set @addValUpdate = 0
	exec sp_executesql @tsql;

	if @is_disabled = 1
	BEGIN
	SET @tsql = 'DISABLE TRIGGER [SSCommon].[' + @table_name + '_TH_IOI] ON SSCommon.' + ISNULL(@TableNamePrefix, '') + @table_name;
	exec sp_executesql @tsql;
	END

	SET @is_disabled = 0;

	SET @ParmDefinition = N'@is_disabledOUT bit OUTPUT';

	SET @tsql = 'if exists (select ob.* from sys.objects ob inner join sys.schemas sch on ob.schema_id = sch.schema_id where ob.name = ''' + @table_Name + '_TH_IOU'' and ob.type = ''TR'' and sch.name = ''SSCommon'')
	BEGIN
	SELECT @is_disabledOUT = tr.is_disabled 
	FROM   sys.tables t
	INNER JOIN sys.schemas s ON t.schema_id = s.schema_id 
	inner join sys.triggers tr on tr.parent_id = t.object_id 
		and tr.type = ''TR'' -- SQL trigger (CLR-owych chyba nie mamy)
		and parent_class = 1 -- DML triggers
	WHERE s.name = ''SSCommon'' AND t.name = ''' + ISNULL(@TableNamePrefix, '') + @table_name + ''' AND tr.name = ''' + @table_name + '_TH_IOU'';
	DROP TRIGGER [SSCommon].[' + @table_name + '_TH_IOU]
	END';

	EXECUTE sp_executesql
	@tsql,
	@ParmDefinition,
	@is_disabledOUT=@is_disabled OUTPUT;

	SET @tsql = 'CREATE TRIGGER [SSCommon].' + @table_name + '_TH_IOU 
   ON SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + '] 
   INSTEAD OF UPDATE
AS 
BEGIN
	SET NOCOUNT ON;

    DECLARE @CI                varchar(128)     = context_info();
    DECLARE @st_modified_by    uniqueidentifier = ''00000000-0000-0000-0000-000000000000'';
    DECLARE @st_replication_id uniqueidentifier = ''00000000-0000-0000-0000-000000000000'';
    DECLARE @st_state          int              = 3;
    DECLARE @st_server         varchar(100)     = RTRIM(CONVERT(char(100), SERVERPROPERTY(''servername'')));
    DECLARE @st_last_modified  datetime         = GETDATE();
    DECLARE @is_mirror_db_guid char(1)          = ''0''
	DECLARE @skip_history      char(1)          = ''0'';
    DECLARE @st_db_guid        uniqueidentifier = ''00000000-0000-0000-0000-000000000000'';    
    DECLARE @endpos            int              = CHARINDEX(''*'', @CI);
    
    if (@endpos > 0)
    BEGIN
	    DECLARE @divpos1 int = CHARINDEX(''@'', @CI);
	    DECLARE @divpos2 int = CHARINDEX(''$'', @CI);
	    DECLARE @divpos6 int = CHARINDEX(''|'', @CI);
	    DECLARE @divpos7 int = CHARINDEX(''#'', @CI);	    	    

        SET @st_modified_by    = SUBSTRING(@CI, 1,            @divpos1 - 1);
	    SET @st_replication_id = SUBSTRING(@CI, @divpos1 + 1, @divpos2 - @divpos1 - 1);
	    SET @is_mirror_db_guid = SUBSTRING(@CI, @divpos6 + 1, @divpos7 - @divpos6 - 1);
		SET @skip_history =		 SUBSTRING(@CI, @divpos7+1,   LEN(@CI) - @divpos7);
	    
	    IF @is_mirror_db_guid = ''1''
	    BEGIN			
			SET @st_db_guid = @st_replication_id;
			SET @st_replication_id = ''00000000-0000-0000-0000-000000000000'';
		END
    END;

    UPDATE SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + ']
        SET 
		' + @InsertedTriggerCols + @InsertedTriggerValCols + ', 
		st_last_modified = @st_last_modified 
     FROM SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + '] as '+ @table_name + '0 INNER JOIN inserted as inserted1 ON (inserted1.[ElementId]='+ @table_name + '0.[ElementId]) ; 

	 ' + ISNULL(@UpdateDimValues, '') + '

	IF(@skip_history <> ''1'')
	BEGIN
	INSERT INTO SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + 'Rep]
	(' + @TriggerCols +','+@AllValCols +'  st_last_modified, st_shadowdata , st_state, st_modified_by, st_host, st_client, st_server, st_replication_id, st_db_guid)
		SELECT 
		    ' + @TriggerCols +','
			+@AllValCols +' 
		    @st_last_modified,
		    NULL,
		    @st_state,
		    @st_modified_by,
		    HOST_NAME(),
		    APP_NAME(),
		    @st_server,
		    @st_replication_id, 
		    @st_db_guid
		FROM inserted;	
	END
END;'

	exec sp_executesql @tsql;

	if @is_disabled = 1
	BEGIN
	SET @tsql = 'DISABLE TRIGGER [SSCommon].[' + @table_name + '_TH_IOU] ON SSCommon.' + ISNULL(@TableNamePrefix, '') + @table_name;
	exec sp_executesql @tsql;
	END

	SET @is_disabled = 0;

	SET @ParmDefinition = N'@is_disabledOUT bit OUTPUT';

	SET @tsql = 'if exists (select ob.* from sys.objects ob inner join sys.schemas sch on ob.schema_id = sch.schema_id where ob.name = ''' + @table_Name + '_TH_AD'' and ob.type = ''TR'' and sch.name = ''SSCommon'')
	BEGIN
	SELECT @is_disabledOUT = tr.is_disabled 
	FROM   sys.tables t
	INNER JOIN sys.schemas s ON t.schema_id = s.schema_id 
	inner join sys.triggers tr on tr.parent_id = t.object_id 
		and tr.type = ''TR'' -- SQL trigger (CLR-owych chyba nie mamy)
		and parent_class = 1 -- DML triggers
	WHERE s.name = ''SSCommon'' AND t.name = ''' + ISNULL(@TableNamePrefix, '') + @table_name + ''' AND tr.name = ''' + @table_name + '_TH_AD'';
	DROP TRIGGER [SSCommon].[' + @table_name + '_TH_AD]
	END';

	EXECUTE sp_executesql
	@tsql,
	@ParmDefinition,
	@is_disabledOUT=@is_disabled OUTPUT;



	SET @tsql = 'CREATE TRIGGER [SSCommon].[' + @table_name + '_TH_AD] 
   ON SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + '] 
   AFTER DELETE
AS 
BEGIN
	SET NOCOUNT ON;
       
    DECLARE @CI                varchar(128)     = context_info();
    DECLARE @st_modified_by    uniqueidentifier = ''00000000-0000-0000-0000-000000000000'';
    DECLARE @st_replication_id uniqueidentifier = ''00000000-0000-0000-0000-000000000000'';
    DECLARE @st_state          int              = 1;
    DECLARE @st_server         varchar(100)     = RTRIM(CONVERT(char(100), SERVERPROPERTY(''servername'')));
    DECLARE @st_last_modified  datetime         = GETDATE();
    DECLARE @is_mirror_db_guid char(1)          = ''0''
    DECLARE @skip_history      char(1)          = ''0''       
    DECLARE @st_db_guid        uniqueidentifier = ''00000000-0000-0000-0000-000000000000'';    
    DECLARE @endpos            int               = CHARINDEX(''*'', @CI);
    
    if (@endpos > 0)
    BEGIN
	    DECLARE @divpos1 int = CHARINDEX(''@'', @CI);
	    DECLARE @divpos2 int = CHARINDEX(''$'', @CI);
	    DECLARE @divpos6 int = CHARINDEX(''|'', @CI);
	    DECLARE @divpos7 int = CHARINDEX(''#'', @CI);	    	    

        SET @st_modified_by    = SUBSTRING(@CI, 1,            @divpos1 - 1);
	    SET @st_replication_id = SUBSTRING(@CI, @divpos1 + 1, @divpos2 - @divpos1 - 1);
	    SET @is_mirror_db_guid = SUBSTRING(@CI, @divpos6 + 1, @divpos7 - @divpos6 - 1);
		SET @skip_history =		 SUBSTRING(@CI, @divpos7+1,   LEN(@CI) - @divpos7);
	    
	    IF @is_mirror_db_guid = ''1''
	    BEGIN			
			SET @st_db_guid = @st_replication_id;
			SET @st_replication_id = ''00000000-0000-0000-0000-000000000000'';
		END
    END;

		IF(@skip_history = ''1'')
		RETURN

		DECLARE @oldrecid int;
		DECLARE @ElementId ';
		
		if @UseIntFK = 0
			set @tsql = @tsql + 'uniqueidentifier;
			'
		else
			set @tsql = @tsql + 'int;
			'

		set @tsql = @tsql + 'DECLARE deletedrows CURSOR LOCAL FAST_FORWARD FOR  		
			SELECT DISTINCT MAX(c.st_seq_id) as st_seq_id, d.[ElementId] 
			FROM SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + 'Rep] c, deleted d 
			WHERE c.Guid = d.Guid
			GROUP BY  d.[ElementId] ;

		OPEN deletedrows;
		';
		
		SET @tsql = @tsql + 'FETCH NEXT FROM deletedrows INTO @oldrecid, @ElementId;

		WHILE @@FETCH_STATUS = 0
		BEGIN

			INSERT INTO SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + 'Rep]
			(
				[ElementId], 
				' + @TriggerWithoutElIdCols + ','
				+ @AllValCols +'
				st_last_modified,
				st_shadowdata,
				st_state,
				st_modified_by,
				st_host,
				st_client,
				st_server,
				st_replication_id, 
				st_db_guid
			)
			SELECT 
				@ElementId,
				' + @TriggerWithoutElIdCols + ','
				+ @AllValCols +'
				st_last_modified,
				st_shadowdata,
				st_state,
				st_modified_by,
				st_host,
				st_client,
				st_server,
				st_replication_id, 
				st_db_guid
			FROM SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + 'Rep] WHERE st_seq_id = @oldrecid;

			DECLARE @newrecid int;
			SET @newrecid = SCOPE_IDENTITY();

			UPDATE SSCommon.[' + ISNULL(@TableNamePrefix, '') + @table_name + 'Rep]  
			SET
				st_last_modified = @st_last_modified,
				st_state = @st_state,
				st_modified_by = @st_modified_by,
				st_host = HOST_NAME(),
				st_client = APP_NAME(),
				st_server = @st_server,
				st_replication_id = @st_replication_id,
				st_db_guid = @st_db_guid
			WHERE st_seq_id = @newrecid;

		FETCH NEXT FROM deletedrows INTO @oldrecid, @ElementId;
	END;

	CLOSE deletedrows;
	DEALLOCATE deletedrows;    

END;'

	set @addColumnsWithValUpdate = 0
	exec sp_executesql @tsql;

	if @is_disabled = 1
	BEGIN
	SET @tsql = 'DISABLE TRIGGER [SSCommon].[' + @table_name + '_TH_AD] ON SSCommon.' + ISNULL(@TableNamePrefix, '') + @table_name;
	exec sp_executesql @tsql;
	END

	SET @is_disabled = 0;

FETCH NEXT FROM ClasVIEWCursos INTO @TableNamePrefix, @table_name, @UseIntFK, @BIMaxCount, @ClasificationId;
END
CLOSE ClasVIEWCursos;
DEALLOCATE ClasVIEWCursos;

IF EXISTS
(SELECT * FROM tempdb.dbo.sysobjects WHERE ID = OBJECT_ID('tempdb..#DictValueUpdates'))
BEGIN
DROP TABLE #DictValueUpdates
END
CREATE TABLE #DictValueUpdates
(
dvUpdate nvarchar(MAX)
);

set @tsql2 = 'insert into #DictValueUpdates 
select ''update c set c.['' + cl2.COLUMN_NAME + ''] = e.Title 
from SSCommon.'' + isnull(c.TableNamePrefix, '''') + c.TableName + '' c 
inner join [SSCommon].[STElements] e on e.'' + case when c.UseIntFK = 0 then ''[Guid]'' else ''[ElementId]'' end + '' = c.['' + cl1.COLUMN_NAME + '']''
from SSCommon.STClasifications c 
inner join SSCommon.STClasificationsDef d on c.ClasificationsDefId = d.Id 
inner join SSCommon.STClasificationDims cdim on cdim.ClasificationsDefId = d.Id 
inner join SSCommon.STDimensions dim on cdim.DimensionsId = dim.Id 
inner join information_schema.columns cl1 on cl1.TABLE_NAME = ISNULL(c.TableNamePrefix, '''') + c.TableName and cl1.COLUMN_NAME = ''CDim_'' + replace(replace(replace(dim.Symbol,''-'',''_''),''.'',''_''), '' '', ''#'') 
inner join information_schema.columns cl2 on cl1.TABLE_NAME = cl2.TABLE_NAME and cl1.COLUMN_NAME + ''_Val'' = cl2.COLUMN_NAME 
where c.SaveDictValues = 1 and dim.ElementKindGuid IS NOT NULL';

exec sp_executesql @tsql2;

DECLARE DictValueUpdatesCursor CURSOR STATIC LOCAL FOR
select dvUpdate from #DictValueUpdates;
OPEN DictValueUpdatesCursor;
FETCH NEXT FROM DictValueUpdatesCursor INTO @tsql;
WHILE @@FETCH_STATUS = 0
BEGIN
	exec sp_executesql @tsql;	
	FETCH NEXT FROM DictValueUpdatesCursor INTO @tsql;
END
close DictValueUpdatesCursor;
deallocate DictValueUpdatesCursor;


GO
ALTER PROCEDURE [HM].[hm_Jpk_GetFaktura]
AS

	SELECT
		dk.id
		,dk.data
		,[kod] =
			CASE
				WHEN dk.typ = 202 THEN dk.kod_obcy
				ELSE dk.kod
			END
		,dk.waluta
		,dk.jpk
		,dk.datasp
		,dk.khadid
		,dk.netto
		,dk.vat
		,dk.walNetto
		,dk.walBrutto
		,[metodaKasowa] = 
			CASE
				WHEN (dk.flag & 0x0080) <> 0 THEN 1
				ELSE 0
			END
		,[samofakturowanie] =
			CASE
				WHEN (dk.flag & 0x0040) <> 0 THEN 1
				ELSE 0
			END
		,dk.splitPayment
		,ad.idKraju
		,[nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END
		,[procOSS] = CASE WHEN sc.CDim_JPK_OSS is NULL THEN 0 ELSE sc.CDim_JPK_OSS END
	FROM HM.DK AS dk
	JOIN ##JpkFaktury AS tmp ON dk.id = tmp.id AND tmp.spid = @@SPID
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification as sc ON sc.ElementId = dk.id
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
GO
ALTER PROCEDURE [HM].[hm_Jpk_GetFakturaKorektaWiersz]
AS
	DECLARE @OO VARCHAR(2) = 'OO'

	SELECT DISTINCT
		dk.id
		,[kod] =
			CASE
				WHEN dk.typ = 202 THEN dk.kod_obcy
				ELSE dk.kod
			END
		,[opis] =
			CASE
				WHEN dp.idlongname IS NOT NULL THEN CAST(tx.opis as varchar(256))
				ELSE CAST(dp.opis as varchar(256))
			END
		,dp.jmwp
		,[ilosc] = dp.iloscwp + dp2.iloscwp
		,dp.cena
		,[wartoscSp] = 
			CASE
				WHEN dk.grupacen = 0 THEN (dp.wartNetto + dp.wartVat) + (dp2.wartNetto + dp2.wartVat)
				ELSE dp.wartNetto + dp2.wartNetto
			END
		,[stawkaVat] = 
			CASE WHEN dp.odwrotneObc = 0 OR dk.typ <> 0 THEN
				CASE 
					WHEN xt.kod = 'NP' OR xt.kod = 'ZW' THEN xt.kod
					ELSE CAST(xt.wartosc * 100 AS varchar)  
				END
			ELSE
				@OO
			END
		,dk.grupacen
		,dp.lp
		,ad.idKraju
		,[nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END
		,xt.wartosc
		,[procOSS] = CASE WHEN sc.CDim_JPK_OSS is NULL THEN 0 ELSE sc.CDim_JPK_OSS END
	FROM HM.DK AS dk
	INNER JOIN HM.DP AS dp ON dp.super = dk.id AND dp.kompensata = 0
	INNER JOIN HM.DP AS dp2 ON dp2.super = dk.id AND dp2.superkoryg = dp.superkoryg AND dp2.lp = dp.lp AND dp2.kompensata = 1
	INNER JOIN HM.XT AS xt ON xt.id = dp.stvat
	LEFT JOIN HM.TX as tx ON tx.id = dp.idlongname
	JOIN ##JpkFaktury AS tmp ON dk.id = tmp.id AND tmp.spid = @@SPID
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification as sc ON sc.ElementId = dk.id
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
	WHERE dk.waluta = '' AND dp.idpozkoryg IS NOT NULL AND (dp.flag & 0x4000) = 0 AND dp2.stvat = dp.stvat
UNION
	SELECT DISTINCT
		dk.id
		,[kod] =
			CASE
				WHEN dk.typ = 202 THEN dk.kod_obcy
				ELSE dk.kod
			END
		,[opis] =
			CASE
				WHEN dp.idlongname IS NOT NULL THEN CAST(tx.opis as varchar(256))
				ELSE CAST(dp.opis as varchar(256))
			END
		,dp.jmwp
		,dp.iloscwp
		,dp.cena
		,[wartoscSp] = 
			CASE
				WHEN dk.grupacen = 0 THEN dp.wartNetto + dp.wartVat
				ELSE dp.wartNetto
			END
		,[stawkaVat] = 
			CASE WHEN dp.odwrotneObc = 0 OR dk.typ <> 0 THEN
				CASE 
					WHEN xt.kod = 'NP' OR xt.kod = 'ZW' THEN xt.kod
					ELSE CAST(xt.wartosc * 100 AS varchar)  
				END
			ELSE
				@OO
			END
		,dk.grupacen
		,dp.lp
		,ad.idKraju
		,[nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END
		,xt.wartosc	
		,[procOSS] = CASE WHEN sc.CDim_JPK_OSS is NULL THEN 0 ELSE sc.CDim_JPK_OSS END
	FROM HM.DK AS dk
	INNER JOIN HM.DP AS dp ON dp.super = dk.id AND dp.kompensata = 0
	INNER JOIN HM.XT AS xt ON xt.id = dp.stvat
	LEFT JOIN HM.TX as tx ON tx.id = dp.idlongname
	JOIN ##JpkFaktury AS tmp ON dk.id = tmp.id AND tmp.spid = @@SPID
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification as sc ON sc.ElementId = dk.id
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
	WHERE dk.waluta = '' AND dp.idpozkoryg IS NULL AND (dp.flag & 0x4000) = 0
UNION
	SELECT DISTINCT
		dk.id
		,[kod] =
			CASE
				WHEN dk.typ = 202 THEN dk.kod_obcy
				ELSE dk.kod
			END
		,[opis] =
			CASE
				WHEN dp.idlongname IS NOT NULL THEN CAST(tx.opis as varchar(256))
				ELSE CAST(dp.opis as varchar(256))
			END
		,dp.jmwp
		,dp.iloscwp
		,dp.cena
		,[wartoscSp] = 
			CASE
				WHEN dk.grupacen = 0 THEN dp.wartNetto + dp.wartVat
				ELSE dp.wartNetto
			END
		,[stawkaVat] = 
			CASE WHEN dp.odwrotneObc = 0 OR dk.typ <> 0 THEN
				CASE 
					WHEN xt.kod = 'NP' OR xt.kod = 'ZW' THEN xt.kod
					ELSE CAST(xt.wartosc * 100 AS varchar)  
				END
			ELSE
				@OO
			END
		,dk.grupacen
		,dp.lp
		,ad.idKraju
		,[nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END
		,xt.wartosc
		,[procOSS] = CASE WHEN sc.CDim_JPK_OSS is NULL THEN 0 ELSE sc.CDim_JPK_OSS END
	FROM HM.DK AS dk
	INNER JOIN HM.DP AS dp ON dp.super = dk.id
	INNER JOIN HM.XT AS xt ON xt.id = dp.stvat
	INNER JOIN HM.DP AS dp2 ON dp2.super = dk.id AND dp2.superkoryg = dp.superkoryg AND dp2.lp = dp.lp
	LEFT JOIN HM.TX as tx ON tx.id = dp.idlongname
	JOIN ##JpkFaktury AS tmp ON dk.id = tmp.id AND tmp.spid = @@SPID
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification as sc ON sc.ElementId = dk.id
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
	WHERE dk.waluta = '' AND dp.idpozkoryg IS NOT NULL AND (dp.flag & 0x4000) = 0 AND dp2.stvat <> dp.stvat
GO
ALTER PROCEDURE [HM].[hm_Jpk_GetFakturaKorektaWierszWaluta]
AS
	DECLARE @OO VARCHAR(2) = 'OO'

	SELECT DISTINCT
		dk.id
		,[kod] =
			CASE
				WHEN dk.typ = 202 THEN dk.kod_obcy
				ELSE dk.kod
			END
		,[opis] =
			CASE
				WHEN dp.idlongname IS NOT NULL THEN CAST(tx.opis as varchar(256))
				ELSE CAST(dp.opis as varchar(256))
			END
		,dp.jmwp
		,[ilosc] = dp.iloscwp + dp2.iloscwp
		,dp.cenawal
		,[wartoscSp] = dp2.walNetto + dp.walNetto
		,[stawkaVat] = 
			CASE WHEN dp.odwrotneObc = 0 OR dk.typ <> 0 THEN
				CASE 
					WHEN xt.kod = 'NP' OR xt.kod = 'ZW' THEN xt.kod
					ELSE CAST(xt.wartosc * 100 AS varchar)  
				END
			ELSE
				@OO
			END
		,dk.grupacen
		,dp.lp
		,ad.idKraju
		,[nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END
		,xt.wartosc	
		,[procOSS] = CASE WHEN sc.CDim_JPK_OSS is NULL THEN 0 ELSE sc.CDim_JPK_OSS END
	FROM HM.DK AS dk
	INNER JOIN HM.DP AS dp ON dp.super = dk.id AND dp.kompensata = 0
	INNER JOIN HM.DP AS dp2 ON dp2.super = dk.id AND dp2.superkoryg = dp.superkoryg AND dp2.lp = dp.lp AND dp2.kompensata = 1 
	INNER JOIN HM.XT AS xt ON xt.id = dp.stvat
	LEFT JOIN HM.TX as tx ON tx.id = dp.idlongname
	JOIN ##JpkFaktury AS tmp ON dk.id = tmp.id AND tmp.spid = @@SPID
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification as sc ON sc.ElementId = dk.id
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
	WHERE dk.waluta <> '' AND dp.idpozkoryg IS NOT NULL AND (dp.flag & 0x4000) = 0 AND dp2.stvat = dp.stvat
UNION
	SELECT DISTINCT
		dk.id
		,[kod] =
			CASE
				WHEN dk.typ = 202 THEN dk.kod_obcy
				ELSE dk.kod
			END
		,[opis] =
			CASE
				WHEN dp.idlongname IS NOT NULL THEN CAST(tx.opis as varchar(256))
				ELSE CAST(dp.opis as varchar(256))
			END
		,dp.jmwp
		,dp.iloscwp
		,dp.cenawal
		,[wartoscSp] = dp.walNetto
		,[stawkaVat] = 
			CASE WHEN dp.odwrotneObc = 0 OR dk.typ <> 0 THEN
				CASE 
					WHEN xt.kod = 'NP' OR xt.kod = 'ZW' THEN xt.kod
					ELSE CAST(xt.wartosc * 100 AS varchar)  
				END
			ELSE
				@OO
			END
		,dk.grupacen
		,dp.lp
		,ad.idKraju
		,[nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END
		,xt.wartosc	
		,[procOSS] = CASE WHEN sc.CDim_JPK_OSS is NULL THEN 0 ELSE sc.CDim_JPK_OSS END
	FROM HM.DK AS dk
	INNER JOIN HM.DP AS dp ON dp.super = dk.id AND dp.kompensata = 0
	INNER JOIN HM.XT AS xt ON xt.id = dp.stvat
	LEFT JOIN HM.TX as tx ON tx.id = dp.idlongname
	JOIN ##JpkFaktury AS tmp ON dk.id = tmp.id AND tmp.spid = @@SPID
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification as sc ON sc.ElementId = dk.id
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
	WHERE dk.waluta <> '' AND dp.idpozkoryg IS NULL AND (dp.flag & 0x4000) = 0
UNION
	SELECT DISTINCT
		dk.id
		,[kod] =
			CASE
				WHEN dk.typ = 202 THEN dk.kod_obcy
				ELSE dk.kod
			END
		,[opis] =
			CASE
				WHEN dp.idlongname IS NOT NULL THEN CAST(tx.opis as varchar(256))
				ELSE CAST(dp.opis as varchar(256))
			END
		,dp.jmwp
		,dp.iloscwp
		,dp.cenawal
		,[wartoscSp] = dp.walNetto
		,[stawkaVat] = 
			CASE WHEN dp.odwrotneObc = 0 OR dk.typ <> 0 THEN
				CASE 
					WHEN xt.kod = 'NP' OR xt.kod = 'ZW' THEN xt.kod
					ELSE CAST(xt.wartosc * 100 AS varchar)  
				END
			ELSE
				@OO
			END
		,dk.grupacen
		,dp.lp
		,ad.idKraju
		,[nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END
		,xt.wartosc	
		,[procOSS] = CASE WHEN sc.CDim_JPK_OSS is NULL THEN 0 ELSE sc.CDim_JPK_OSS END
	FROM HM.DK AS dk
	INNER JOIN HM.DP AS dp ON dp.super = dk.id
	INNER JOIN HM.XT AS xt ON xt.id = dp.stvat
	INNER JOIN HM.DP AS dp2 ON dp2.super = dk.id AND dp2.superkoryg = dp.superkoryg AND dp2.lp = dp.lp
	LEFT JOIN HM.TX as tx ON tx.id = dp.idlongname
	JOIN ##JpkFaktury AS tmp ON dk.id = tmp.id AND tmp.spid = @@SPID
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification as sc ON sc.ElementId = dk.id
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
	WHERE dk.waluta <> '' AND dp.idpozkoryg IS NOT NULL AND (dp.flag & 0x4000) = 0 AND dp2.stvat <> dp.stvat
GO
ALTER PROCEDURE [HM].[hm_Jpk_GetFakturaWiersz]
AS
	DECLARE @OO VARCHAR(2) = 'OO'

	SELECT
		dp.super
		,[kod] =
			CASE
				WHEN dk.typ = 202 THEN dk.kod_obcy
				ELSE dk.kod
			END
		,[opis] = 
			CASE
				WHEN dp.idlongname IS NOT NULL THEN CAST(tx.opis as varchar(256))
				ELSE CAST(dp.opis as varchar(256))
			END
		,dp.jmwp
		,dp.iloscwp
		,dp.cena
		,[wartoscSp] = 
			CASE
				WHEN dk.grupacen = 0 THEN dp.wartNetto + dp.wartVat
				ELSE dp.wartNetto
			END
		,[stawkaVat] = 
			CASE WHEN dp.odwrotneObc = 0 OR dk.typ <> 0 THEN
				CASE 
					WHEN xt.kod = 'NP' OR xt.kod = 'ZW' THEN xt.kod
					WHEN xt.kod <> 'NP' OR xt.kod <>'ZW' THEN CAST(xt.wartosc * 100 AS varchar)  
				END
			ELSE
				@OO
			END
		,dk.grupacen
		,dp.lp
		,ad.idKraju
		,[nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END
		,xt.wartosc
		,[procOSS] = CASE WHEN sc.CDim_JPK_OSS is NULL THEN 0 ELSE sc.CDim_JPK_OSS END
	FROM HM.DK AS dk
	JOIN ##JpkFaktury AS tmp ON dk.id = tmp.id AND tmp.spid = @@SPID
	JOIN HM.DP AS dp ON dk.id = dp.super
	JOIN HM.XT AS xt ON xt.id = dp.stvat
	LEFT JOIN HM.TX AS tx ON tx.id = dp.idlongname
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification as sc ON sc.ElementId = dk.id
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
	WHERE dk.waluta = '' AND (dp.flag & 0x4000) = 0
GO
ALTER PROCEDURE [HM].[hm_Jpk_GetFakturaWierszWaluta]
AS
	DECLARE @OO VARCHAR(2) = 'OO'

	SELECT
		dp.super
		,[kod] =
			CASE
				WHEN dk.typ = 202 THEN dk.kod_obcy
				ELSE dk.kod
			END
		,[opis] = 
			CASE
				WHEN dp.idlongname IS NOT NULL THEN CAST(tx.opis as varchar(256))
				ELSE CAST(dp.opis as varchar(256))
			END
		,dp.jmwp
		,dp.iloscwp
		,dp.cenawal
		,[wartoscSp] = dp.walNetto
		,[stawkaVat] = 
			CASE WHEN dp.odwrotneObc = 0 OR dk.typ <> 0 THEN
				CASE 
					WHEN xt.kod = 'NP' OR xt.kod = 'ZW' THEN xt.kod
					WHEN xt.kod <> 'NP' OR xt.kod <>'ZW' THEN CAST(xt.wartosc * 100 AS varchar)  
				END
			ELSE
				@OO
			END
		,dk.grupacen
		,dp.lp
		,ad.idKraju
		,[nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END
		,xt.wartosc
		,[procOSS] = CASE WHEN sc.CDim_JPK_OSS is NULL THEN 0 ELSE sc.CDim_JPK_OSS END
	FROM HM.DK AS dk
	JOIN ##JpkFaktury AS tmp ON dk.id = tmp.id AND tmp.spid = @@SPID
	JOIN HM.DP AS dp ON dk.id = dp.super
	JOIN HM.XT AS xt ON xt.id = dp.stvat
	LEFT JOIN HM.TX AS tx ON tx.id = dp.idlongname
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification as sc ON sc.ElementId = dk.id
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
	WHERE dk.waluta <> '' AND (dp.flag & 0x4000) = 0
GO
ALTER PROCEDURE [HM].[hm_Jpk_GetZaliczkiDoFakturaWiersz] @id INT
AS
DECLARE @OO VARCHAR(2) = 'OO';
--sprzedaz
SELECT dp.super,
       [kod] = CASE
                   WHEN DK.typ = 202 THEN
                       DK.kod_obcy
                   ELSE
                       DK.kod
               END,
       [opis] = CASE
                    WHEN dp.idlongname IS NOT NULL THEN
                        CAST(tx.opis AS VARCHAR(256))
                    ELSE
                        CAST(dp.opis AS VARCHAR(256))
                END,
       dp.jmwp,
       dp.iloscwp,
       dp.cena,
       [wartoscSp] = CASE
                         WHEN DK.grupacen = 0 THEN
                             dp.wartNetto + dp.wartVat
                         ELSE
                             dp.wartNetto
                     END,
       [stawkaVat] = CASE
                         WHEN dp.odwrotneObc = 0
                              OR DK.typ <> 0 THEN
                             CASE
                                 WHEN xt.kod = 'NP'
                                      OR xt.kod = 'ZW' THEN
                                     xt.kod
                                 WHEN xt.kod <> 'NP'
                                      OR xt.kod <> 'ZW' THEN
                                     CAST(xt.wartosc * 100 AS VARCHAR)
                             END
                         ELSE
                             @OO
                     END,
       DK.grupacen,
       dp.wartVat AS VatWartosc,
	   ad.idKraju,
	   [nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END,
	   xt.wartosc
FROM HM.ZZ zety
    JOIN HM.DK DK
        ON DK.id = zety.id1
    JOIN HM.DP AS dp
        ON DK.id = dp.super
    JOIN HM.XT AS xt
        ON xt.id = dp.stvat
    LEFT JOIN HM.TX AS tx
        ON tx.id = dp.idlongname
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
WHERE (dp.flag & 0x4000) = 0
      AND
      (
          zety.id2 = @id
          AND zety.subtyp = 134
          AND baza1 = 16
          AND baza2 = 16
      ) -- faktury zwyke zaliczkowe i kontrakty
      OR
      (
          zety.id1 = @id
          AND zety.subtyp = 152
          AND baza1 = 16
          AND baza2 = 16
      ) -- faktury zaliczkowe i kontrakty w walucie
UNION
-- zakup
SELECT dp.super,
       [kod] = CASE
                   WHEN dk.typ = 202 THEN
                       dk.kod_obcy
                   ELSE
                       dk.kod
               END,
       [opis] = CASE
                    WHEN dp.idlongname IS NOT NULL THEN
                        CAST(tx.opis AS VARCHAR(256))
                    ELSE
                        CAST(dp.opis AS VARCHAR(256))
                END,
       dp.jmwp,
       dp.iloscwp * -1,
       dp.cena,
       [wartoscSp] = CASE
                         WHEN dk.grupacen = 0 THEN
                             dp.wartNetto + dp.wartVat
                         ELSE
                             dp.wartNetto
                     END * -1,
       [stawkaVat] = CASE
                         WHEN dp.odwrotneObc = 0
                              OR dk.typ <> 0 THEN
                             CASE
                                 WHEN xt.kod = 'NP'
                                      OR xt.kod = 'ZW' THEN
                                     xt.kod
                                 WHEN xt.kod <> 'NP'
                                      OR xt.kod <> 'ZW' THEN
                                     CAST(xt.wartosc * 100 AS VARCHAR)
                             END
                         ELSE
                             @OO
                     END,
       dk.grupacen,
       dp.wartVat * -1 AS VatWartosc,
	   ad.idKraju,
	   [nip] = CASE WHEN scc.NIP is NULL THEN 0 ELSE CASE WHEN scc.NIP = '' THEN 0 ELSE 1 END END,
	   xt.wartosc
FROM hm.zz zety
    JOIN hm.zo dk
        ON dk.id = zety.id1
           AND baza1 = 46
           AND baza2 = 34
           AND zety.subtyp = 128
    JOIN hm.zp dp
        ON dp.super = dk.id
    JOIN HM.XT AS xt
        ON xt.id = dp.stvat
    LEFT JOIN HM.TX AS tx
        ON tx.id = dp.idlongname
	JOIN HM.AD as ad ON ad.id = dk.khadid
	LEFT JOIN SSCommon.STContractors as scc ON scc.Id = dk.khid
WHERE zety.id2 = @id;
GO
ALTER PROCEDURE [HM].[hm_Jpk_GetZaliczkiDoFaktura]
AS
SELECT zamowienia.id,
       zety.kod2,
       CASE zety.subtyp 
	  WHEN 128 THEN zamowienia.walBrutto*-1
	  ELSE zamowienia.walBrutto END walBrutto,
	  [procOSS] = CASE WHEN ssc.CDim_JPK_OSS is NULL THEN 0 ELSE ssc.CDim_JPK_OSS END
FROM ##JpkFaktury AS tmp
    JOIN HM.ZZ zety
        ON zety.id2 = tmp.id
    JOIN HM.DK zamowienia
        ON (
               zamowienia.id = zety.id1
               AND zety.subtyp = 136
               AND zety.baza1 = 16
               AND zety.baza2 = 16
           )
           OR
           (
               zamowienia.id = zety.id2
               AND zety.subtyp = 128
               AND baza1 = 46
               AND baza2 = 34
           )
           OR
           (
               zamowienia.id = zety.id1
               AND zety.subtyp = 152
               AND zety.baza1 = 16
               AND zety.baza2 = 16
           )
	LEFT JOIN SSCommon.HMF_SalesInvoiceClassification ssc on ssc.ElementId = tmp.id
WHERE tmp.spid = @@SPID;
